// Based on Arduino Playground tutorial: http://www.arduino.cc/playground/Learning/Tutorial01

//import class to set up serial connection with wiring board
import processing.serial.*;
Serial port;
//button setup
color currentcolor;
RectButton rect1, rect2, rect3, rect4, rect5;
boolean locked = false;
void setup() {
  //set up window
  size(350, 150);
  color baseColor = color(0, 0, 0);
  currentcolor = baseColor;
  // List all the available serial ports in the output pane. 
  // You will need to choose the port that the Wiring board is 
  // connected to from this list. The first port in the list is 
  // port #0 and the third port in the list is port #2. 
  println(Serial.list()); 
  // Open the port that the Wiring board is connected to (in this case 1
  // which is the second open port in the array) 
  // Make sure to open the port at the same speed Wiring is at 9600bps for HC-05 
  port = new Serial(this, "/dev/tty.HC-05-DevB", 9600);  //use the serial device that blueman has setup
  // Define and create rectangle button #1
  int x = 30;
  int y = height/2;
  int size = 50;
  color buttoncolor = color(153, 0, 0);
  color highlight = color(255, 0, 0); 
  rect1 = new RectButton(x, y, size, buttoncolor, highlight);
  // Define and create rectangle button #2
  x = 90;
  y = height/2; 
  size = 50;
  buttoncolor = color(0, 153, 0);
  highlight = color(0, 255, 0); 
  rect2 = new RectButton(x, y, size, buttoncolor, highlight);
  // Define and create rectangle button #3

  x = 150;
  y = height/2; 
  size = 50;
  buttoncolor = color(0, 0, 153);
  highlight = color(0, 0, 255);
rect3 = new RectButton(x, y, size, buttoncolor, highlight);
  // Define and create rectangle button #4
x = 210;
  y = height/2; 
  size = 50;
  buttoncolor = color(153, 153, 153);
  highlight = color(255, 255, 255);
rect4 = new RectButton(x, y, size, buttoncolor, highlight);  
// Define and create rectangle button #5
x = 270;
  y = height/2; 
  size = 50;
  buttoncolor = color(0, 0, 0);
  highlight = color(102, 102, 102);
rect5 = new RectButton(x, y, size, buttoncolor, highlight);
}
void draw() {
  background(currentcolor);
  stroke(255);
  update(mouseX, mouseY);
  rect1.display();
  rect2.display();
  rect3.display();
  rect4.display();
  rect5.display();

}
void update(int x, int y) {
  if(locked == false) {
    rect1.update();
    rect2.update();
    rect3.update();
    rect4.update();
    rect5.update();

  } 
  else {
    locked = false;
  }
//Select 
  if(mousePressed) {
    if(rect1.pressed()) {            //Red button
      currentcolor = rect1.basecolor;
      port.write('3');
    } 
    else if(rect2.pressed()) {    //Green button
      currentcolor = rect2.basecolor;
      port.write('1');
    }
    else if(rect3.pressed()) {    //Blue button
      currentcolor = rect3.basecolor;
      port.write('2');
    }
    else if(rect4.pressed()) {    //White button
      currentcolor = rect4.basecolor;
      port.write('4');
    }
    else if(rect5.pressed()) {    //OFF button
      currentcolor = rect5.basecolor;
      port.write('5');
    }
  }
}
class Button {
  int x, y;
  int size;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   
  void update() 
  {
    if(over()) {
      currentcolor = highlightcolor;
    } 
    else {
      currentcolor = basecolor;
    }
  }
  boolean pressed() 
  {
    if(over) {
      locked = true;
      return true;
    } 
    else {
      locked = false;
      return false;
    }
  }
  boolean over() 
  { 
    return true;
  }
  void display() 
  {
  }
}
class RectButton extends Button {
  RectButton(int ix, int iy, int isize, color icolor, color ihighlight) 
  {
    x = ix;
    y = iy;
    size = isize;
    basecolor = icolor;
    highlightcolor = ihighlight;
    currentcolor = basecolor;
  }
  boolean over() 
  {
    if( overRect(x, y, size, size) ) {
      over = true;
      return true;
    } 
    else {
      over = false;
      return false;
    }
  }
  void display() 
  {
    stroke(255);
    fill(currentcolor);
    rect(x, y, size, size);
  }
}
boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
    mouseY >= y && mouseY <= y+height) {
    return true;
  } 
  else {
    return false;
  }
}

